#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_pushButton_clicked()
{
    qDebug() << "Transforme /tmp/fichier.ogg en wav ... lancé";
    AbulEduAudioV1::OggToWave oggDecoder;
    QString fichierOgg = "/tmp/fichier.ogg";
    QString fichierWav = "/tmp/fichier.wav";
    oggDecoder.processOggFile(fichierOgg, fichierWav);
    qDebug() << "Transforme /tmp/fichier.ogg en wav ... terminé";
}

void MainWindow::on_pushButton_2_clicked()
{
    qDebug() << "Transforme /tmp/fichier.wav en ogg ... lancé";
    m_oggEncoder = new AbulEduAudioV1::WaveToOgg(this);

    connect(m_oggEncoder, SIGNAL(signalWaveToOggStatus(WaveToOgg::Status,WaveHeaderReader::Status,QString)), this, SLOT(slotWaveEncoderStatus(WaveToOgg::Status,WaveHeaderReader::Status,QString)), Qt::UniqueConnection);
    connect(m_oggEncoder, SIGNAL(signalWaveToOggProcessPercent(float)), this, SLOT(slotWaveEncoderProcessPercent(float)));

    QString fichierOgg = "/tmp/fichier2.ogg";
    QString fichierWav = "/tmp/fichier.wav";
    m_oggEncoder->processWavFile(fichierWav, fichierOgg);

//    qDebug() << "Transforme /tmp/fichier.wav en ogg ... terminé";
}

void MainWindow::slotWaveEncoderStatus(AbulEduAudioV1::WaveToOgg::Status statusWave,AbulEduAudioV1::WaveHeaderReader::Status statusHeader,QString cheminFichier)
{
    ABULEDU_LOG_TRACE() << __PRETTY_FUNCTION__ << " : " << statusWave << " : " << statusHeader << " et " << cheminFichier;
    qDebug() << __PRETTY_FUNCTION__ << " : " << statusWave << " : " << statusHeader << " et " << cheminFichier;


    /* Recuperation name enum  WaveToOgg::Status */
    const QMetaObject &moWaveToOgg = AbulEduAudioV1::WaveToOgg::staticMetaObject;
    QMetaEnum meWaveToOgg = moWaveToOgg.enumerator(moWaveToOgg.indexOfEnumerator("Status"));

    /* Recuperation name enum  WaveHeaderReader::Status */
    const QMetaObject &moWaveHeaderReader = AbulEduAudioV1::WaveHeaderReader::staticMetaObject;
    QMetaEnum meWaveHeaderReader = moWaveHeaderReader.enumerator(moWaveHeaderReader.indexOfEnumerator("Status"));

    qDebug() << (QString("Status Encoder : %1").arg(QString(meWaveToOgg.valueToKey(statusWave))));
    qDebug() << (QString("Status WaveReader : %1").arg(QString(meWaveHeaderReader.valueToKey(statusHeader))));

    if(statusWave == AbulEduAudioV1::WaveToOgg::EncoderAvailable){
        m_oggEncoder->encodeWavFile();
    }

    /* si 3 conditions ci-dessous, le fichier est converti & ok */
    if(statusWave == AbulEduAudioV1::WaveToOgg::ProcessOK && statusHeader == AbulEduAudioV1::WaveHeaderReader::FileOK && !cheminFichier.isEmpty()){
            qDebug() << "Conversion Fichier OK";
            qDebug() << "Le chemin du fichier :: " << cheminFichier;
    }

}

void MainWindow::slotWaveEncoderProcessPercent(float f)
{
    qDebug() << "Progression : " << f;
}
